from ultralytics import YOLO
import argparse

if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    '''
    parser.add_argument('--weights', type=str, default='yolov8n.pt', help='initial weights path')
    parser.add_argument('--cfg', type=str, default='', help='model.yaml path')
    parser.add_argument('--data', type=str, default='', help='data.yaml path')
    parser.add_argument('--epochs', type=int, default=300)
    parser.add_argument('--batch', type=int, default=16, help='total batch size for all GPUs')
    parser.add_argument('--imgsize', nargs='+', type=int, default=640, help='[train, test] image sizes')
    parser.add_argument('--device', type=int, default=0, help='cuda device, i.e. 0 or 0,1,2,3 or cpu')
    parser.add_argument('--workers', type=int, default=8, help='maximum number of dataloader workers')
    parser.add_argument('--project', default='', help='save to project/name')
    parser.add_argument('--name', default='', help='save to project/name')
    parser.add_argument('--optimizer', default='auto', help='use [SGD, Adam, Adamax, AdamW, NAdam, RAdam, RMSProp, auto] optimizer')
    parser.add_argument('--randseed', type=int, default=0, help='(int)set RandomSeed')
    parser.add_argument('--lr0', type=float, default=0.01, help='(float) initial learning rate (i.e. SGD=1E-2, Adam=1E-3)')
    parser.add_argument('--momentum', type=float, default=0.937, help='(float) SGD momentum/Adam beta1')
    parser.add_argument('--weight_decay', type=float, default=0.0005, help='(float) optimizer weight decay 5e-4')
    parser.add_argument('--hsvh', type=float, default=0.015, help='(float) image HSV-Hue augmentation (fraction)')
    parser.add_argument('--hsvs', type=float, default=0.7, help='(float) image HSV-Saturation augmentation (fraction)')
    parser.add_argument('--hsvv', type=float, default=0.4, help='(float) image HSV-Value augmentation (fraction)')
    parser.add_argument('--degrees', type=float, default=0.0, help='(float) image rotation (+/- deg)')
    parser.add_argument('--translate', type=float, default=0.1, help='(float) image translation (+/- fraction)')
    parser.add_argument('--scale', type=float, default=0.5, help='(float) image scale (+/- gain)')
    parser.add_argument('--flipud', type=float, default=0.0, help='(float) image flip up-down (probability)')
    parser.add_argument('--fliplr', type=float, default=0.5, help='(float) image flip left-right (probability)')
    parser.add_argument('--mosaic', type=float, default=1.0, help='(float) image mosaic (probability)')
    parser.add_argument('--mixup', type=float, default=0.0, help='(float) image mixup (probability)')
    '''
    # Lemon
    parser.add_argument('--weights', type=str, default='E:/test/yolov8m.pt', help='initial weights path')
    parser.add_argument('--cfg', type=str, default='', help='model.yaml path')
    parser.add_argument('--data', type=str, default='E:/AIData/code_3/AI_param/classification_weight/20231101_1401/train_param/YOLOV5_Data.yaml', help='data.yaml path')
    parser.add_argument('--epochs', type=int, default=7500)
    parser.add_argument('--batch', type=int, default=3, help='total batch size for all GPUs')
    parser.add_argument('--imgsize', nargs='+', type=int, default=224, help='[train, test] image sizes')
    parser.add_argument('--device', type=int, default=0, help='cuda device, i.e. 0 or 0,1,2,3 or cpu')
    parser.add_argument('--workers', type=int, default=8, help='maximum number of dataloader workers')
    parser.add_argument('--project', default='E:/AIData/code_3/AI_param/classification_weight/20231101_1401', help='save to project/name')
    parser.add_argument('--name', default='try1', help='save to project/name')
    parser.add_argument('--optimizer', default='auto', help='use [SGD, Adam, Adamax, AdamW, NAdam, RAdam, RMSProp, auto] optimizer')
    parser.add_argument('--randseed', type=int, default=0, help='(int)set RandomSeed')
    parser.add_argument('--lr0', type=float, default=0.01, help='(float) initial learning rate (i.e. SGD=1E-2, Adam=1E-3)')
    parser.add_argument('--momentum', type=float, default=0.937, help='(float) SGD momentum/Adam beta1')
    parser.add_argument('--weight_decay', type=float, default=0.0005, help='(float) optimizer weight decay 5e-4')
    parser.add_argument('--hsvh', type=float, default=0.015, help='(float) image HSV-Hue augmentation (fraction)')
    parser.add_argument('--hsvs', type=float, default=0.7, help='(float) image HSV-Saturation augmentation (fraction)')
    parser.add_argument('--hsvv', type=float, default=0.4, help='(float) image HSV-Value augmentation (fraction)')
    parser.add_argument('--degrees', type=float, default=2.0, help='(float) image rotation (+/- deg)')
    parser.add_argument('--translate', type=float, default=0.1, help='(float) image translation (+/- fraction)')
    parser.add_argument('--scale', type=float, default=0.5, help='(float) image scale (+/- gain)')
    parser.add_argument('--flipud', type=float, default=0.5, help='(float) image flip up-down (probability)')
    parser.add_argument('--fliplr', type=float, default=0.5, help='(float) image flip left-right (probability)')
    parser.add_argument('--mosaic', type=float, default=1.0, help='(float) image mosaic (probability)')
    parser.add_argument('--mixup', type=float, default=0.0, help='(float) image mixup (probability)')
    opt = parser.parse_args()
    # Load a model
    model = YOLO(opt.weights)  # load a pretrained model (recommended for training)
    # Train the model
    model.train(data=opt.data,
                epochs=opt.epochs,
                batch=opt.batch,
                imgsz=opt.imgsize,
                device=opt.device,
                workers=opt.workers,
                project=opt.project,
                name=opt.name,
                optimizer=opt.optimizer,
                seed=opt.randseed,
                lr0=opt.lr0,
                lrf=0.2,
                momentum=opt.momentum,
                weight_decay=opt.weight_decay,
                hsv_h=opt.hsvh,
                hsv_s=opt.hsvs,
                hsv_v=opt.hsvv,
                degrees=opt.degrees,
                translate=opt.translate,
                scale=opt.scale,
                flipud=opt.flipud,
                fliplr=opt.fliplr,
                mosaic=opt.mosaic,
                mixup=opt.mixup,
                overlap_mask=False
                )

